DefInt A-Z

Option Explicit

' --------------------------------------------------------
' This is an example application that illustrates how to
' use some of the functions in Ver.dll, to retrieve file
' information embedded into a file with the resource
' compiler (RC.EXE).
'
' For more information, please consult the following
' documents:
'     Microsoft Windows 3.1 Programmer's Reference,
'        Vols. 2 & 3
'     SDK Reference Help File (Win31wh.hlp) from Windows
'        3.1 SDK
'
' This program was modeled after the Verstamp sample
' program included in the Microsoft Windows Software
' Development Kit.  The Global Constants below are defined
' in the Ver.H header file, also included in Microsoft
' C/C++ 7.0, and the Windows SDK.
' --------------------------------------------------------


Type VS_VERSION
   wLength            As Integer
   wValueLength       As Integer
   szKey              As String * 16 ' "VS_VERSION_INFO"
   
   dwSignature        As Long        ' VS_FIXEDFILEINFO struct
   dwStrucVersion     As Long
   dwFileVersionMS    As Long
   dwFileVersionLS    As Long
   dwProductVersionMS As Long
   dwProductVersionLS As Long
   dwFileFlagsMasks   As Long
   dwFileFlags        As Long
   dwFileOS           As Long
   dwFileType         As Long
   dwFileSubType      As Long
   dwFileDateMS       As Long
   dwFileDateLS       As Long
End Type

Declare Function GetFileVersionInfo% Lib "Ver.dll" (ByVal FileName$, ByVal dwHandle&, ByVal cbBuff&, ByVal lpvData$)
Declare Function GetFileVersionInfoSize& Lib "Ver.dll" (ByVal FileName$, dwHandle&)
Declare Sub hmemcpy Lib "kernel" (hpvDest As Any, hpvSrc As Any, ByVal cbBytes&)

Function HIWORD% (x&)
   HIWORD% = x& \ &HFFFF&
End Function

Function LOWORD% (x&)
   LOWORD% = x& And &HFFFF&
End Function

Sub ReturnVerInfo (FullFileName$, FileVer$, ProdVer$)

   
   Dim dwHandle&, BufSize&
   Dim r%
   Dim lpvData$

   Dim x As VS_VERSION


   ' -----------------------------------------------------
   ' Determine if there is a File Version number or
   '   Product Version number
   ' -----------------------------------------------------
   BufSize& = GetFileVersionInfoSize(FullFileName$, dwHandle&)
   If BufSize& = 0 Then
      FileVer$ = "0": ProdVer$ = "0"
      Exit Sub
   End If

   
   ' -----------------------------------------------------
   ' Now that we have the size, get the actual information
   ' -----------------------------------------------------
   lpvData$ = Space$(BufSize&)
   r% = GetFileVersionInfo(FullFileName$, dwHandle&, BufSize&, lpvData$)
   hmemcpy x, ByVal lpvData$, Len(x)


   ' -----------------------------------------------------
   ' Determine File Version number
   ' -----------------------------------------------------
   FileVer$ = LTrim$(Str$(HIWORD(x.dwFileVersionMS))) + "."
   FileVer$ = FileVer$ + LTrim$(Str$(LOWORD(x.dwFileVersionMS))) + "."
   FileVer$ = FileVer$ + LTrim$(Str$(HIWORD(x.dwFileVersionLS))) + "."
   FileVer$ = FileVer$ + LTrim$(Str$(LOWORD(x.dwFileVersionLS)))

   
   ' -----------------------------------------------------
   ' Determine Product Version number
   ' -----------------------------------------------------
   ProdVer$ = LTrim$(Str$(HIWORD(x.dwFileVersionMS))) + "."
   ProdVer$ = ProdVer$ + LTrim$(Str$(LOWORD(x.dwProductVersionMS))) + "."
   ProdVer$ = ProdVer$ + LTrim$(Str$(HIWORD(x.dwProductVersionLS))) + "."
   ProdVer$ = ProdVer$ + LTrim$(Str$(LOWORD(x.dwProductVersionLS)))


End Sub

